local addon, shared = ...

local RELEASE=		99
local WDOGYIELD=	15
local FUNCTIONRUN=	10
local STATUSUPDT=	8
local INFORMATION=	5
local DETAIL=		1

---------------------
-- Variables
---------------------

_MoneyBags = {}
local MB = _MoneyBags

MB.UIElements = {
	tracker = {
		context = "",
		frDims = {
			hdr_iw = 0,
			hdr_tw = 0,
			lbl_w = 0,
			val_w = 0,
			w32 = 0
		}
	},
	summary = {
		context = "",
		frDims = {
			actual = {
				cncy = 0,
				strt = 0,
				gain = 0,
				loss = 0,
				nett = 0,
				crnt = 0
			},
			header = {
				cncy = 0,
				strt = 0,
				gain = 0,
				loss = 0,
				nett = 0,
				crnt = 0
			},
			detail = {
				icon = 0,
				cncy = 0,
				strt = 0,
				gain = 0,
				loss = 0,
				nett = 0,
				crnt = 0
			}			
		},
		curBars = {}
	},
	controlpanel = {}
}

MB.UIElements.tracker.context = UI.CreateContext("MBtracker")
MB.UIElements.summary.context = UI.CreateContext("MBsummary")
MB.UIElements.controlpanel.context = UI.CreateContext("MBcontrolpanel")

MB.UIElements.summary.hdr_background = UI.CreateFrame("Frame", "MB.UIElements.summary.hdr_background", MB.UIElements.summary.context)

local curCategories = {
	{ id = "N0000000048953585" }, -- Coin
	{ id = "N0000000250762B60" }, -- Sourcestone
	{ id = "N000000034BC4E1B2" }, -- PvP
	{ id = "N000000047B0C65D0" }, -- Dungeons
	{ id = "N00000005647BD7B1" }, -- Raids
	{ id = "N0000000651CF8491" }, -- Crafting
	{ id = "N000000070E02A786" }, -- Artifacts
	{ id = "N0000000974C0AD64" }  -- Events
}

local curDetails = {}

local curSetup = {
	{ k="coin", name = "Platinum, Gold, Silver", iSrc = "MoneyBags", iName = "textures/platinum.png" },	
	{ k="credit", name = "Credits", iSrc = "MoneyBags", iName = "textures/credits.png" },	
	{ k="I23EC07294CF25F4F,0B7088EC08332BA4,,,,,,", name = "Inscribed Sourcestone", iSrc = "Rift", iName = "item_icons\\mystical_stone1.dds" },
	{ k="I55D15DD03901D399,78251F12B9E71F7B,,,,,,", name = "Vile Sourcestone", iSrc = "Rift", iName = "item_icons\\sourcestone_01.dds" },
	{ k="I3EB9CA353D9AD5DD,0D7809C9E476D8EC,,,,,,", name = "Cursed Sourcestone", iSrc = "Rift", iName = "item_icons\\sourcestone_02z_z.dds" },
	{ k="I0AE22E5E3ACC1511,0951C0BA04A69EB2,,,,,,", name = "Corrupted Sourcestone", iSrc = "Rift", iName = "item_icons\\sourcestone_04.dds" },
	{ k="I40FE419D87662CDA,018726C4E158FF25,,,,,,", name = "Planarite", iSrc = "Rift", iName = "item_icons\\planarite_orb_b.dds" },
	{ k="IFCDE9C6FBEB45C94,27BB32E16A21D0FA,,,,,,", name = "Infinity Stone", iSrc = "Rift", iName = "item_icons\\stone_infinity.dds" },
	{ k="IFE4271A6B90859C0,2D2084EC52EBB033,,,,,,", name = "Empyreal Sourcestone", iSrc = "Rift", iName = "item_icons\\stone_empyrean.dds" },
	{ k="I1BE979014977916D,D836143579B97398,,,,,,", name = "Favor", iSrc = "Rift", iName = "item_icons\\trinket5.dds" },
	{ k="I71FE70EA7E88C7E7,03B4D7D70AF85529,,,,,,", name = "Freelancer's Mark of Conquest", iSrc = "Rift", iName = "item_icons\\conquest.dds" },
	{ k="I57A6918E4DF98C9B,E4D763C7EA8B5F46,,,,,,", name = "Mark of Conquest", iSrc = "Rift", iName = "item_icons\\conquest.dds" },
	{ k="I46C2877F229D9E7F,17EE6DFBD8FDD7D5,,,,,,", name = "Freelancer's Mark", iSrc = "Rift", iName = "item_icons\\mark_mercenary.dds" },
	{ k="I06FAC3BB2616F31A,38ADE308AC5BAB2F,,,,,,", name = "Warlord's Mark", iSrc = "Rift", iName = "item_icons\\mark_warlord.dds" },
	{ k="I5DAA5D94859ABEE8,F31D1D28EEF60D6C,,,,,,", name = "Empyreal Slayer's Mark", iSrc = "Rift", iName = "item_icons\\mark_empyrean_slayers.dds" },	
	{ k="I5BF06F2671F0EC54,05BA7B38362820FD,,,,,,", name = "Plaque of Achievement", iSrc = "Rift", iName = "item_icons\\plaque_of_achievement.dds" },
	{ k="I3574109FCBD046B5,F2E46CA6349204AD,,,,,,", name = "Infernal Mark of Ascension", iSrc = "Rift", iName = "item_icons\\card31a.dds" },
	{ k="I75C01F728AFC0B2D,F1F9078F0F98563A,,,,,,", name = "Frozen Eclipse Stone", iSrc = "Rift", iName = "item_icons\\stone_frozen_eclipse.dds	" },
	{ k="I012105E7427E4E3E,62A361267F2B352F,,,,,,", name = "Greater Mark of Ascension", iSrc = "Rift", iName = "item_icons\\card30a.dds" },
	{ k="I6558F675C827A2B6,2E7F820579C85B7A,,,,,,", name = "Mark of Ascension", iSrc = "Rift", iName = "item_icons\\card30c.dds" },
	{ k="I2D199E412D5BD46E,DEFE32C2157DE5B1,,,,,,", name = "Artisan's Mark", iSrc = "Rift", iName = "item_icons\\trinket27a.dds" },	
	{ k="I21D9052625C52295,709CF1BA97DA8BF9,,,,,,", name = "Master Craftsman's Mark", iSrc = "Rift", iName = "item_icons\\card28a.dds" },
	{ k="I4CD48A0656A66436,41331FF662BDB8ED,,,,,,", name = "Grandmaster Craftsman's Mark", iSrc = "Rift", iName = "item_icons\\mark_craftsmans.dds" },
	{ k="I1A4C950D19699749,029E4A8BC265B92C,,,,,,", name = "Lucky Coin", iSrc = "Rift", iName = "item_icons\\trinket8.dds" },
	{ k="I1D4DBBF16CA700FE,F9333FFB8C8BCD01,,,,,,", name = "Prize Ticket", iSrc = "Rift", iName = "item_icons\\page_42_a.dds" },	
	{ k="I1D4DBBEFA7CD789C,C74E282A0DFDA0DC,,,,,,", name = "Glass Beads", iSrc = "Rift", iName = "item_icons\\necklace_chain_damaged_01_b.dds" },
	{ k="I1438537A9C47E241,D7881C3F052F7FD0,,,,,,", name = "Summerfest Merit Badge", iSrc = "Rift", iName = "item_icons\\1h_shield_007.dds" },
	{ k="I0F2238CD4EF112EE,12AE11AE41A804E0,,,,,,", name = "Summerfest Friendship Bracelet", iSrc = "Rift", iName = "item_icons\\bracelet_beaded_ornate_01_b.dds" },
	{ k="I3584618666602B00,42A5ABDB6AE0C639,,,,,,", name = "Unique Snowflake", iSrc = "Rift", iName = "ability_icons\\shaman-vengeance_of_winter_storm.dds" },
	{ k="I01E3CFEF69F4CFDB,23BE0CC727302AEC,,,,,,", name = "Autumn Harvest Ambersap", iSrc = "Rift", iName = "item_icons\\magical_sap3.dds" },
	{ k="I6B8952E078685EAE,1490E66C2E78471D,,,,,,", name = "Autumn Harvest Signet", iSrc = "Rift", iName = "item_icons\\fatestone_07_yellow.dds" },
	{ k="I3C4D61CC50ADD3C8,4FEE8025B2FD6E72,,,,,,", name = "Auroral Doubloons", iSrc = "Rift", iName = "item_icons\\molly_tag.dds" },
}

--local curDetailsRev = {}
curDetailsRev = {}
for k,v in pairs(curDetails) do
	curDetailsRev[v.pos] = {name = v.name, id = k }
end

local numKnownCurrency = #curSetup

local coroDead = false

local frNeeded = true
local svLoaded = false
local frameOrderNeeded = false
local resizeNeeded = false
local firstrun = false
local controlvis = false
local sumtextUpdateNeeded = false

local _CurrentDay = os.date("%Y%m%d")
local _CurrentMth = os.date("%Y%m")

local _activeDate = _CurrentDay

local default_settings = {
	history = {},
	monthly = {},
	x = 500, y = 500,
	sumx = 600, sumy = 600, active = 1, visible = true
}

local _session = {}
local _daystart = {}

local _sumtxtupdate = {}
local _summode = "D"

---------------------
-- Functions
---------------------

local debuglevel = RELEASE

local function Debug(s,l)
	if (l or INFORMATION) >= debuglevel then
		print(s)
	end
end

local yieldcnt = 0
local function WATCHDOGWAIT(x)
	local rmx = Inspect.System.Watchdog()
	while rmx < 0.075 do
		yieldcnt = yieldcnt+1
		Debug("#"..yieldcnt..":rmx: "..rmx.." ["..x.."]",WDOGYIELD)
		coroutine.yield()
		rmx = Inspect.System.Watchdog()
	end
end

local function MergeTable(o,n)
	for k,v in pairs(n) do
		if type(v) == "table" then
			if o[k] == nil then
				o[k] = {}				
			end
	 	 	if type(o[k]) == 'table' then
	 			MergeTable(o[k], n[k])
	 	 	end
		else
			if o[k] == nil then
				o[k] = v
			end
		end
	end
end

function MB.checkMouse()
	local t = MB.UIElements.controlpanel.frame:GetTop()
	local b = MB.UIElements.controlpanel.frame:GetBottom()
	local l = MB.UIElements.controlpanel.frame:GetLeft()
	local r = MB.UIElements.controlpanel.frame:GetRight()
	local md = Inspect.Mouse()
	if md.x < l or md.x > r or md.y < t or md.y > b then
		controlvis = false
		MB.UIElements.controlpanel.panel:SetVisible(false)
	end
end

function MB.scaleTracker()
	Debug("S:scaleTracker()",FUNCTIONRUN)
	
	WATCHDOGWAIT("scaleTracker:1")
	
	local scale = MoneyBags_Settings.scale or 1
	local w32 = 32 * scale
	local h14 = 14 * scale
	local h32 = w32
	
	MB.UIElements.tracker.frDims.w32 = w32
	
	MB.UIElements.tracker.icon:SetWidth(w32)
	MB.UIElements.tracker.icon:SetHeight(w32)

	MB.UIElements.tracker.curName:SetFontSize(h14)
	local h = MB.UIElements.tracker.curName:GetHeight()
	MB.UIElements.tracker.frDims.hdr_iw = h
	MB.UIElements.tracker.hdr_background:SetHeight(h)
	
	MB.UIElements.controlpanel.frame:SetHeight(h + h32)
	MB.UIElements.controlpanel.panel:SetHeight(h32)
	
	MB.UIElements.controlpanel.ctrl_strt:SetHeight(h32)
	MB.UIElements.controlpanel.ctrl_strt:SetWidth(h32)
	MB.UIElements.controlpanel.ctrl_rewd:SetHeight(h32)
	MB.UIElements.controlpanel.ctrl_rewd:SetWidth(h32)
	MB.UIElements.controlpanel.ctrl_ffor:SetHeight(h32)
	MB.UIElements.controlpanel.ctrl_ffor:SetWidth(h32)
	MB.UIElements.controlpanel.ctrl_end:SetHeight(h32)
	MB.UIElements.controlpanel.ctrl_end:SetWidth(h32)
	
	WATCHDOGWAIT("scaleTracker:2")
	
	MB.UIElements.tracker.l_curCurrent:SetFontSize(h14)
	MB.UIElements.tracker.l_curCurrent:ClearWidth()
	local w = MB.UIElements.tracker.l_curCurrent:GetWidth()
	MB.UIElements.tracker.frDims.lbl_w = w
	MB.UIElements.tracker.l_curGain:SetFontSize(h14)
	MB.UIElements.tracker.l_curLoss:SetFontSize(h14)
	MB.UIElements.tracker.l_curNett:SetFontSize(h14)
	MB.UIElements.tracker.curCurrent:SetFontSize(h14)
	MB.UIElements.tracker.curGain:SetFontSize(h14)
	MB.UIElements.tracker.curLoss:SetFontSize(h14)
	MB.UIElements.tracker.curNett:SetFontSize(h14)

	WATCHDOGWAIT("scaleTracker:3")
	
	MB.SetTrackerText()
	Debug("E:scaleTracker()",FUNCTIONRUN)
end

function MB.BuildUIElements()
	Debug("S:MB.BuildUIElements()",FUNCTIONRUN)
	
	WATCHDOGWAIT("BuildUIElements:1")

	MB.UIElements.minimap = UI.CreateFrame("Texture", "MB.UIElements.minimap", MB.UIElements.tracker.context)
	MB.UIElements.minimap:SetHeight(36)
	MB.UIElements.minimap:SetWidth(36)
	MB.UIElements.minimap:SetTexture(addon.identifier, "textures/mm_button.png")

	if MINIMAPDOCKER then
		MINIMAPDOCKER.Register(addon.identifier, MB.UIElements.minimap)
	else
		MB.UIElements.minimap:EventAttach(Event.UI.Input.Mouse.Left.Down, function(self, h)
			self.MouseDown = true
			local mouseData = Inspect.Mouse()
			self.sx = mouseData.x - MB.UIElements.minimap:GetLeft()
			self.sy = mouseData.y - MB.UIElements.minimap:GetTop()
		end, "Event.UI.Input.Mouse.Left.Down")
		
		MB.UIElements.minimap:EventAttach(Event.UI.Input.Mouse.Cursor.Move, function(self, h)
			if self.MouseDown then
				local nx, ny
				local mouseData = Inspect.Mouse()
				nx = mouseData.x - self.sx
				ny = mouseData.y - self.sy
				MB.UIElements.minimap:SetPoint("TOPLEFT", UIParent, "TOPLEFT", nx,ny)
			end
		end, "Event.UI.Input.Mouse.Cursor.Move")
		
		MB.UIElements.minimap:EventAttach(Event.UI.Input.Mouse.Left.Up, function(self, h)
			if self.MouseDown then
				self.MouseDown = false
			end
			MoneyBags_Settings.mmx = MB.UIElements.minimap:GetLeft()
			MoneyBags_Settings.mmy = MB.UIElements.minimap:GetTop()
		end, "Event.UI.Input.Mouse.Left.Up")
	end
	
	MB.UIElements.minimap:EventAttach(Event.UI.Input.Mouse.Right.Click, function(self, h)
		MoneyBags_Settings.visible = not MoneyBags_Settings.visible
		MB.UIElements.tracker.icon:SetVisible(MoneyBags_Settings.visible)
		if MoneyBags_Settings.visible == false then
			MB.UIElements.summary.hdr_background:SetVisible(false)
		end
	end, "Event.UI.Input.Mouse.Right.Click")
	
	MB.UIElements.tracker.icon = UI.CreateFrame("Texture", "MB.UIElements.tracker.icon", MB.UIElements.tracker.context)
	MB.UIElements.tracker.icon:SetVisible(false)
	
	WATCHDOGWAIT("BuildUIElements:SetTexture:platinum.png")
	MB.UIElements.tracker.icon:SetTexture(addon.identifier, "textures/platinum.png")
	MB.UIElements.tracker.icon:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 500, 500)
	
	MB.UIElements.tracker.icon:EventAttach(Event.UI.Input.Mouse.Left.Down, function(self, h)
		self.MouseDown = true
		local mouseData = Inspect.Mouse()
		self.sx = mouseData.x - MB.UIElements.tracker.icon:GetLeft()
		self.sy = mouseData.y - MB.UIElements.tracker.icon:GetTop()
	end, "Event.UI.Input.Mouse.Left.Down")
	
	MB.UIElements.tracker.icon:EventAttach(Event.UI.Input.Mouse.Cursor.Move, function(self, h)
		if self.MouseDown then
			local nx, ny
			local mouseData = Inspect.Mouse()
			nx = mouseData.x - self.sx
			ny = mouseData.y - self.sy
			MB.UIElements.tracker.icon:SetPoint("TOPLEFT", UIParent, "TOPLEFT", nx,ny)
		end
	end, "Event.UI.Input.Mouse.Cursor.Move")
	
	MB.UIElements.tracker.icon:EventAttach(Event.UI.Input.Mouse.Left.Up, function(self, h)
		if self.MouseDown then
			self.MouseDown = false
		end
		MoneyBags_Settings.x = MB.UIElements.tracker.icon:GetLeft()
		MoneyBags_Settings.y = MB.UIElements.tracker.icon:GetTop()
	end, "Event.UI.Input.Mouse.Left.Up")
	
	MB.UIElements.tracker.icon:EventAttach(Event.UI.Input.Mouse.Right.Click, function(self, h)
		local frvis = MB.UIElements.summary.hdr_background:GetVisible()
		frvis = not frvis
		MB.UIElements.summary.hdr_background:SetVisible(frvis)
	end, "Event.UI.Input.Mouse.Right.Click")
	
	WATCHDOGWAIT("BuildUIElements:2")

	MB.UIElements.tracker.hdr_background = UI.CreateFrame("Frame", "MB.UIElements.tracker.hdr_background", MB.UIElements.tracker.icon)
	MB.UIElements.tracker.hdr_background:SetPoint("TOPLEFT", MB.UIElements.tracker.icon, "TOPRIGHT", 0,0)
	MB.UIElements.tracker.hdr_background:SetLayer(-10)
	MB.UIElements.tracker.hdr_background:SetBackgroundColor(0,0,0,0.5)
	MB.UIElements.tracker.hdr_background:EventAttach(Event.UI.Input.Mouse.Cursor.In, function(self, h)
		controlvis = true
		MB.UIElements.controlpanel.panel:SetVisible(true)
	end, "Event.UI.Input.Mouse.Cursor.In")

	MB.UIElements.controlpanel.frame = UI.CreateFrame("Frame", "MB.UIElements.controlpanel.frame", MB.UIElements.controlpanel.context)
	MB.UIElements.controlpanel.frame:SetPoint("BOTTOMLEFT", MB.UIElements.tracker.hdr_background, "BOTTOMLEFT", 0,0)
	MB.UIElements.controlpanel.frame:SetLayer(-20)
	MB.UIElements.controlpanel.frame:SetVisible(false)
	MB.UIElements.controlpanel.frame:EventAttach(Event.UI.Input.Mouse.Cursor.Out, function(self, h)
		MB.checkMouse()
	end, "Event.UI.Input.Mouse.Cursor.Out")
	
	MB.UIElements.controlpanel.panel = UI.CreateFrame("Frame", "MB.UIElements.controlpanel.panel", MB.UIElements.controlpanel.context)
	MB.UIElements.controlpanel.panel:SetVisible(false)
	MB.UIElements.controlpanel.panel:SetPoint("BOTTOMLEFT", MB.UIElements.tracker.hdr_background, "TOPLEFT", 0,0)
	MB.UIElements.controlpanel.panel:SetBackgroundColor(0,0,0.5,1)
	MB.UIElements.controlpanel.panel:SetLayer(5)
	
	MB.UIElements.controlpanel.ctrl_strt = UI.CreateFrame("Texture", "MB.UIElements.controlpanel.ctrl_strt", MB.UIElements.controlpanel.panel)
	WATCHDOGWAIT("BuildUIElements:SetTexture:control_start.png")
	MB.UIElements.controlpanel.ctrl_strt:SetTexture(addon.identifier, "textures/control_start.png")
	MB.UIElements.controlpanel.ctrl_strt:SetPoint("BOTTOMLEFT", MB.UIElements.controlpanel.panel, "BOTTOMLEFT", 0,0)
	MB.UIElements.controlpanel.ctrl_strt:SetLayer(10)
	MB.UIElements.controlpanel.ctrl_strt:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		MoneyBags_Settings.active = 1
		MB.SetTrackerText()
	end, "Event.UI.Input.Mouse.Left.Click")
	MB.UIElements.controlpanel.ctrl_strt:EventAttach(Event.UI.Input.Mouse.Cursor.Out, function(self, h)
		MB.checkMouse()
	end, "Event.UI.Input.Mouse.Cursor.Out")
	
	WATCHDOGWAIT("BuildUIElements:3")

	MB.UIElements.controlpanel.ctrl_rewd = UI.CreateFrame("Texture", "MB.UIElements.controlpanel.ctrl_rewd", MB.UIElements.controlpanel.panel)
	WATCHDOGWAIT("BuildUIElements:SetTexture:control_rewind.png")
	MB.UIElements.controlpanel.ctrl_rewd:SetTexture(addon.identifier, "textures/control_rewind.png")
	MB.UIElements.controlpanel.ctrl_rewd:SetPoint("TOPLEFT", MB.UIElements.controlpanel.ctrl_strt, "TOPRIGHT", 0,0)
	MB.UIElements.controlpanel.ctrl_rewd:SetLayer(10)
	MB.UIElements.controlpanel.ctrl_rewd:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		local s = MoneyBags_Settings.active
		s = s-1
		for x = s, 1, -1 do
			local i = curDetailsRev[x].id
			if curDetails[i].seen == true then
				MoneyBags_Settings.active = x
				break
			end
		end
		MB.SetTrackerText()
	end, "Event.UI.Input.Mouse.Left.Click")
	MB.UIElements.controlpanel.ctrl_rewd:EventAttach(Event.UI.Input.Mouse.Cursor.Out, function(self, h)
		MB.checkMouse()
	end, "Event.UI.Input.Mouse.Cursor.Out")

	MB.UIElements.controlpanel.ctrl_ffor = UI.CreateFrame("Texture", "MB.UIElements.controlpanel.ctrl_ffor", MB.UIElements.controlpanel.panel)
	WATCHDOGWAIT("BuildUIElements:SetTexture:control_fastforward.png")
	MB.UIElements.controlpanel.ctrl_ffor:SetTexture(addon.identifier, "textures/control_fastforward.png")
	MB.UIElements.controlpanel.ctrl_ffor:SetPoint("TOPLEFT", MB.UIElements.controlpanel.ctrl_rewd, "TOPRIGHT", 0,0)
	MB.UIElements.controlpanel.ctrl_ffor:SetLayer(10)
	MB.UIElements.controlpanel.ctrl_ffor:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		local s = MoneyBags_Settings.active
		s = s+1
		for x = s, numKnownCurrency, 1 do
			local i = curDetailsRev[x].id
			if curDetails[i].seen == true then
				MoneyBags_Settings.active = x
				break
			end
		end
		MB.SetTrackerText()
	end, "Event.UI.Input.Mouse.Left.Click")
	MB.UIElements.controlpanel.ctrl_ffor:EventAttach(Event.UI.Input.Mouse.Cursor.Out, function(self, h)
		MB.checkMouse()
	end, "Event.UI.Input.Mouse.Cursor.Out")

	WATCHDOGWAIT("BuildUIElements:4")
	
	MB.UIElements.controlpanel.ctrl_end = UI.CreateFrame("Texture", "MB.UIElements.controlpanel.ctrl_end", MB.UIElements.controlpanel.panel)
	WATCHDOGWAIT("BuildUIElements:SetTexture:control_end.png")
	MB.UIElements.controlpanel.ctrl_end:SetTexture(addon.identifier, "textures/control_end.png")
	MB.UIElements.controlpanel.ctrl_end:SetPoint("TOPLEFT", MB.UIElements.controlpanel.ctrl_ffor, "TOPRIGHT", 0,0)
	MB.UIElements.controlpanel.ctrl_end:SetLayer(10)
	MB.UIElements.controlpanel.ctrl_end:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		local s = numKnownCurrency
		for x = s, 1, -1 do
			local i = curDetailsRev[x].id
			if curDetails[i].seen == true then
				MoneyBags_Settings.active = x
				break
			end
		end
		MB.SetTrackerText()
	end, "Event.UI.Input.Mouse.Left.Click")
	MB.UIElements.controlpanel.ctrl_end:EventAttach(Event.UI.Input.Mouse.Cursor.Out, function(self, h)
		MB.checkMouse()
	end, "Event.UI.Input.Mouse.Cursor.Out")

	MB.UIElements.tracker.curName = UI.CreateFrame("Text", "MB.UIElements.tracker.curName", MB.UIElements.tracker.icon)
	MB.UIElements.tracker.curName:SetText("curName")
	MB.UIElements.tracker.curName:SetPoint("TOPCENTER", MB.UIElements.tracker.hdr_background, "TOPCENTER", 0,0)	

	WATCHDOGWAIT("BuildUIElements:5")

	MB.UIElements.tracker.l_curCurrent = UI.CreateFrame("Text", "MB.UIElements.tracker.l_curCurrent", MB.UIElements.tracker.icon)
	MB.UIElements.tracker.l_curCurrent:SetText("Current:")
	MB.UIElements.tracker.l_curCurrent:SetPoint("TOPLEFT", MB.UIElements.tracker.hdr_background, "BOTTOMLEFT", 0,0)

	MB.UIElements.tracker.l_curGain = UI.CreateFrame("Text", "MB.UIElements.tracker.l_curGain", MB.UIElements.tracker.icon)
	MB.UIElements.tracker.l_curGain:SetText("Gain:")
	MB.UIElements.tracker.l_curGain:SetPoint("TOPLEFT", MB.UIElements.tracker.l_curCurrent, "BOTTOMLEFT", 0,0)

	MB.UIElements.tracker.l_curLoss = UI.CreateFrame("Text", "MB.UIElements.tracker.l_curLoss", MB.UIElements.tracker.icon)
	MB.UIElements.tracker.l_curLoss:SetText("Loss:")
	MB.UIElements.tracker.l_curLoss:SetPoint("TOPLEFT", MB.UIElements.tracker.l_curGain, "BOTTOMLEFT", 0,0)

	WATCHDOGWAIT("BuildUIElements:6")
	
	MB.UIElements.tracker.l_curNett = UI.CreateFrame("Text", "MB.UIElements.tracker.l_curNett", MB.UIElements.tracker.icon)
	MB.UIElements.tracker.l_curNett:SetText("Nett:")
	MB.UIElements.tracker.l_curNett:SetPoint("TOPLEFT", MB.UIElements.tracker.l_curLoss, "BOTTOMLEFT", 0,0)

	MB.UIElements.tracker.curCurrent = UI.CreateFrame("Text", "MB.UIElements.tracker.curCurrent", MB.UIElements.tracker.icon)
	MB.UIElements.tracker.curCurrent:SetText("0")
	MB.UIElements.tracker.curCurrent:SetPoint("TOPLEFT", MB.UIElements.tracker.l_curCurrent, "TOPRIGHT", 0,0)

	MB.UIElements.tracker.curGain = UI.CreateFrame("Text", "MB.UIElements.tracker.curGain", MB.UIElements.tracker.icon)
	MB.UIElements.tracker.curGain:SetText("0")
	MB.UIElements.tracker.curGain:SetFontColor(0,1,0)
	MB.UIElements.tracker.curGain:SetPoint("TOPLEFT", MB.UIElements.tracker.curCurrent, "BOTTOMLEFT", 0,0)

	WATCHDOGWAIT("BuildUIElements:7")
	
	MB.UIElements.tracker.curLoss = UI.CreateFrame("Text", "MB.UIElements.tracker.curLoss", MB.UIElements.tracker.icon)
	MB.UIElements.tracker.curLoss:SetText("0")
	MB.UIElements.tracker.curLoss:SetFontColor(1,0,0)
	MB.UIElements.tracker.curLoss:SetPoint("TOPLEFT", MB.UIElements.tracker.curGain, "BOTTOMLEFT", 0,0)

	MB.UIElements.tracker.curNett = UI.CreateFrame("Text", "MB.UIElements.tracker.curNett", MB.UIElements.tracker.icon)
	MB.UIElements.tracker.curNett:SetText("0")
	MB.UIElements.tracker.curNett:SetPoint("TOPLEFT", MB.UIElements.tracker.curLoss, "BOTTOMLEFT", 0,0)

	WATCHDOGWAIT("BuildUIElements:8")	
	
	MB.UIElements.tracker.background = UI.CreateFrame("Frame", "MB.UIElements.tracker.background", MB.UIElements.tracker.icon)
	MB.UIElements.tracker.background:SetPoint("TOPLEFT", MB.UIElements.tracker.l_curCurrent, "TOPLEFT", 0,0)
	MB.UIElements.tracker.background:SetPoint("BOTTOMLEFT", MB.UIElements.tracker.l_curNett, "BOTTOMLEFT", 0,0)
	MB.UIElements.tracker.background:SetPoint("TOPRIGHT", MB.UIElements.tracker.hdr_background, "BOTTOMRIGHT", 0,0)
	MB.UIElements.tracker.background:SetLayer(-10)
	MB.UIElements.tracker.background:SetBackgroundColor(0,0,0,0.25)
	
	local curNeeded = true

	while curNeeded do
		local d = Inspect.Currency.Detail("coin")
		if d.stack == nil then
			coroutine.yield()
		else
			curNeeded = false
		end
	end
	
	for k,v in pairs(Inspect.Currency.Detail(Inspect.Currency.List())) do
		WATCHDOGWAIT("BuildUIElements:9:"..v.name)
		if curDetails[k] == nil then
			print(string.format("NOTICE: New currency detected [%s,%s : %s]", v.name, k, v.icon))
			numKnownCurrency = numKnownCurrency+1
			curDetails[k] = {name = v.name, pos=numKnownCurrency, seen=false, iName = v.icon}
		end
		curDetails[k].name = v.name
		curDetails[k].seen = true
		local ix = curDetails[k].pos
		curDetailsRev[ix] = {name = v.name, id = k }
		MB.mk_sumFrame(k, v)
		_session[v.name] = {start=v.stack, gain=0, loss=0}
		_daystart[v.name]= {start=v.stack}
	end
	
	WATCHDOGWAIT("BuildUIElements:10")
	
	MB.UIElements.summary.hdr_background:SetVisible(false)
	MB.UIElements.summary.hdr_background:SetBackgroundColor(0,0,0,0.5)
	MB.UIElements.summary.hdr_background:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 600,600)
	MB.UIElements.summary.hdr_background:SetLayer(-1)
	
	MB.UIElements.summary.ctrl_cncl = UI.CreateFrame("Texture", "MB.UIElements.summary.ctrl_cncl", MB.UIElements.summary.hdr_background)
	WATCHDOGWAIT("BuildUIElements:SetTexture:cancel.png")
	MB.UIElements.summary.ctrl_cncl:SetTexture(addon.identifier, "textures/cancel.png")
	MB.UIElements.summary.ctrl_cncl:SetPoint("TOPRIGHT", MB.UIElements.summary.hdr_background, "TOPRIGHT", 0,0)
	MB.UIElements.summary.ctrl_cncl:SetLayer(1)

	WATCHDOGWAIT("BuildUIElements:11")
	
	MB.UIElements.summary.ctrl_cncl:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		MB.UIElements.summary.hdr_background:SetVisible(false)
	end, "Event.UI.Input.Mouse.Left.Click")
	
	MB.UIElements.summary.background = UI.CreateFrame("Frame", "MB.UIElements.summary.background", MB.UIElements.summary.hdr_background)
	MB.UIElements.summary.background:SetBackgroundColor(0,0,0,0.25)
	MB.UIElements.summary.background:SetPoint("TOPLEFT", MB.UIElements.summary.hdr_background, "BOTTOMLEFT", 0,0)
	MB.UIElements.summary.background:SetLayer(-1)
	
	MB.UIElements.summary.L1 = UI.CreateFrame("Frame", "MB.UIElements.summary.L1", MB.UIElements.summary.hdr_background)
	MB.UIElements.summary.L1:SetPoint("TOPLEFT", MB.UIElements.summary.hdr_background, "TOPLEFT", 0,0)

	WATCHDOGWAIT("BuildUIElements:12")
	
	MB.UIElements.summary.L1:EventAttach(Event.UI.Input.Mouse.Left.Down, function(self, h)
		self.MouseDown = true
		local mouseData = Inspect.Mouse()
		self.sx = mouseData.x - MB.UIElements.summary.hdr_background:GetLeft()
		self.sy = mouseData.y - MB.UIElements.summary.hdr_background:GetTop()
	end, "Event.UI.Input.Mouse.Left.Down")
	
	MB.UIElements.summary.L1:EventAttach(Event.UI.Input.Mouse.Cursor.Move, function(self, h)
		if self.MouseDown then
			local nx, ny
			local mouseData = Inspect.Mouse()
			nx = mouseData.x - self.sx
			ny = mouseData.y - self.sy
			MB.UIElements.summary.hdr_background:SetPoint("TOPLEFT", UIParent, "TOPLEFT", nx,ny)
		end
	end, "Event.UI.Input.Mouse.Cursor.Move")
	
	MB.UIElements.summary.L1:EventAttach(Event.UI.Input.Mouse.Left.Up, function(self, h)
		if self.MouseDown then
			self.MouseDown = false
		end
		MoneyBags_Settings.sumx = MB.UIElements.summary.hdr_background:GetLeft()
		MoneyBags_Settings.sumy = MB.UIElements.summary.hdr_background:GetTop()
	end, "Event.UI.Input.Mouse.Left.Up")

	MB.UIElements.summary.L2 = UI.CreateFrame("Frame", "MB.UIElements.summary.L2", MB.UIElements.summary.hdr_background)
	MB.UIElements.summary.L2:SetPoint("TOPLEFT", MB.UIElements.summary.L1, "BOTTOMLEFT", 0,0)

	MB.UIElements.summary.L3 = UI.CreateFrame("Frame", "MB.UIElements.summary.L3", MB.UIElements.summary.hdr_background)
	MB.UIElements.summary.L3:SetPoint("TOPLEFT", MB.UIElements.summary.L2, "BOTTOMLEFT", 0,0)
	
	MB.UIElements.summary.hdr_text = UI.CreateFrame("Text", "MB.UIElements.summary.hdr_text", MB.UIElements.summary.hdr_background)
	MB.UIElements.summary.hdr_text:SetText("MoneyBags Summary")
	MB.UIElements.summary.hdr_text:SetPoint("CENTER", MB.UIElements.summary.L1, "CENTER", 0,0)
	MB.UIElements.summary.hdr_text:SetLayer(1)
	
	WATCHDOGWAIT("BuildUIElements:13")
	
	MB.UIElements.summary.hdr_period = UI.CreateFrame("Text", "MB.UIElements.summary.hdr_period", MB.UIElements.summary.hdr_background)
	MB.UIElements.summary.hdr_period:SetText("Period: ".._CurrentDay)
	MB.UIElements.summary.hdr_period:SetPoint("CENTER", MB.UIElements.summary.L2, "CENTER", 0,0)
	MB.UIElements.summary.hdr_period:SetLayer(1)
	
	MB.UIElements.summary.hdr_period:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		if _summode == "D" then
			_summode = "M"
			_activeDate = _CurrentMth
		elseif _summode == "M" then
			_summode = "S"
			_activeDate = "Current Session"
		elseif _summode == "S" then
			_summode = "D"
			_activeDate = _CurrentDay
		end
		MB.UIElements.summary.hdr_period:SetText("Period: ".._activeDate)
		for k,v in pairs(curDetails) do
			if v.seen then
				_sumtxtupdate[v.name] = true
			end
		end
		sumtextUpdateNeeded = true
	end, "Event.UI.Input.Mouse.Left.Click")
	
	MB.UIElements.summary.ctrl_strt = UI.CreateFrame("Texture", "MB.UIElements.summary.ctrl_strt", MB.UIElements.summary.hdr_background)
	WATCHDOGWAIT("BuildUIElements:SetTexture:control_start.png")
	MB.UIElements.summary.ctrl_strt:SetTexture(addon.identifier, "textures/control_start.png")
	MB.UIElements.summary.ctrl_strt:SetPoint("TOPLEFT", MB.UIElements.summary.L2, "TOPLEFT", 0,0)
	MB.UIElements.summary.ctrl_strt:SetLayer(1)
	MB.UIElements.summary.ctrl_strt:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		MB.changePeriod("F")
	end, "Event.UI.Input.Mouse.Left.Click")
	
	WATCHDOGWAIT("BuildUIElements:14")

	MB.UIElements.summary.ctrl_rewd = UI.CreateFrame("Texture", "MB.UIElements.summary.ctrl_rew", MB.UIElements.summary.hdr_background)
	WATCHDOGWAIT("BuildUIElements:SetTexture:control_rewind.png")
	MB.UIElements.summary.ctrl_rewd:SetTexture(addon.identifier, "textures/control_rewind.png")
	MB.UIElements.summary.ctrl_rewd:SetPoint("TOPLEFT", MB.UIElements.summary.ctrl_strt, "TOPRIGHT", 0,0)
	MB.UIElements.summary.ctrl_rewd:SetLayer(1)
	MB.UIElements.summary.ctrl_rewd:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		MB.changePeriod("P")
	end, "Event.UI.Input.Mouse.Left.Click")
	
	MB.UIElements.summary.ctrl_end = UI.CreateFrame("Texture", "MB.UIElements.summary.ctrl_end", MB.UIElements.summary.hdr_background)
	WATCHDOGWAIT("BuildUIElements:SetTexture:control_end.png")
	MB.UIElements.summary.ctrl_end:SetTexture(addon.identifier, "textures/control_end.png")
	MB.UIElements.summary.ctrl_end:SetPoint("TOPRIGHT", MB.UIElements.summary.L2, "TOPRIGHT", 0,0)
	MB.UIElements.summary.ctrl_end:SetLayer(1)
	MB.UIElements.summary.ctrl_end:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		MB.changePeriod("L")
	end, "Event.UI.Input.Mouse.Left.Click")

	WATCHDOGWAIT("BuildUIElements:15")

	MB.UIElements.summary.ctrl_ffor = UI.CreateFrame("Texture", "MB.UIElements.summary.ctrl_ffor", MB.UIElements.summary.hdr_background)
	WATCHDOGWAIT("BuildUIElements:SetTexture:control_fastforward.png")
	MB.UIElements.summary.ctrl_ffor:SetTexture(addon.identifier, "textures/control_fastforward.png")
	MB.UIElements.summary.ctrl_ffor:SetPoint("TOPRIGHT", MB.UIElements.summary.ctrl_end, "TOPLEFT", 0,0)
	MB.UIElements.summary.ctrl_ffor:SetLayer(1)
	MB.UIElements.summary.ctrl_ffor:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		MB.changePeriod("N")
	end, "Event.UI.Input.Mouse.Left.Click")
	
	MB.UIElements.summary.L3text = {}
	
	MB.UIElements.summary.L3text.cname = UI.CreateFrame("Text", "MB.UIElements.summary.L3text.cname", MB.UIElements.summary.hdr_background)
	MB.UIElements.summary.L3text.cname:SetText("CURRENCY")
	MB.UIElements.summary.L3text.cname:SetPoint("TOPLEFT", MB.UIElements.summary.L3, "TOPLEFT", 0,0)
	MB.UIElements.summary.L3text.cname:SetLayer(1)

	WATCHDOGWAIT("BuildUIElements:16")
	
	MB.UIElements.summary.L3text.start = UI.CreateFrame("Text", "MB.UIElements.summary.L3text.start", MB.UIElements.summary.hdr_background)
	MB.UIElements.summary.L3text.start:SetText("START")
	MB.UIElements.summary.L3text.start:SetPoint("TOPLEFT", MB.UIElements.summary.L3text.cname, "TOPRIGHT", 0,0)
	MB.UIElements.summary.L3text.start:SetLayer(1)
	
	MB.UIElements.summary.L3text.gain = UI.CreateFrame("Text", "MB.UIElements.summary.L3text.gain", MB.UIElements.summary.hdr_background)
	MB.UIElements.summary.L3text.gain:SetText("GAINED")
	MB.UIElements.summary.L3text.gain:SetPoint("TOPLEFT", MB.UIElements.summary.L3text.start, "TOPRIGHT", 0,0)
	MB.UIElements.summary.L3text.gain:SetLayer(1)

	WATCHDOGWAIT("BuildUIElements:17")

	MB.UIElements.summary.L3text.loss = UI.CreateFrame("Text", "MB.UIElements.summary.L3text.loss", MB.UIElements.summary.hdr_background)
	MB.UIElements.summary.L3text.loss:SetText("LOST")
	MB.UIElements.summary.L3text.loss:SetPoint("TOPLEFT", MB.UIElements.summary.L3text.gain, "TOPRIGHT", 0,0)
	MB.UIElements.summary.L3text.loss:SetLayer(1)
	
	MB.UIElements.summary.L3text.nett = UI.CreateFrame("Text", "MB.UIElements.summary.L3text.nett", MB.UIElements.summary.hdr_background)
	MB.UIElements.summary.L3text.nett:SetText("NETT")
	MB.UIElements.summary.L3text.nett:SetPoint("TOPLEFT", MB.UIElements.summary.L3text.loss, "TOPRIGHT", 0,0)
	MB.UIElements.summary.L3text.nett:SetLayer(1)

	WATCHDOGWAIT("BuildUIElements:18")
	
	MB.UIElements.summary.L3text.crnt = UI.CreateFrame("Text", "MB.UIElements.summary.L3text.crnt", MB.UIElements.summary.hdr_background)
	MB.UIElements.summary.L3text.crnt:SetText("CURRENT")
	MB.UIElements.summary.L3text.crnt:SetPoint("TOPLEFT", MB.UIElements.summary.L3text.nett, "TOPRIGHT", 0,0)
	MB.UIElements.summary.L3text.crnt:SetLayer(1)
	
	MB.UIElements.tracker.icon:SetVisible(true)
	Debug("E:MB.BuildUIElements()",FUNCTIONRUN)
end

function MB.changePeriod(m)
	if _summode == "S" then return end
	
	local alldates = {}
	local changed = false
	
	local cnt=0
	
	if _summode == "D" then
		for k,v in pairs(MoneyBags_Settings.history) do
			table.insert(alldates, k)
			cnt=cnt+1
		end
		Debug(string.format("M: %s, Added: %d", _summode, cnt), INFORMATION)
	elseif _summode == "M" then
		for k,v in pairs(MoneyBags_Settings.monthly) do
			table.insert(alldates, k)
			cnt=cnt+1
		end	
		Debug(string.format("M: %s, Added: %d", _summode, cnt), INFORMATION)
	end
		
	table.sort(alldates)
	Debug(string.format("1 = "..alldates[1]), DETAIL)
	Debug(string.format("# = "..#alldates), DETAIL)
	Debug(string.format("L = "..alldates[#alldates]), DETAIL)

	if (m=="L" or m=="N") then
		Debug(string.format("m: %s [%s] [%s]", m, alldates[#alldates], _activeDate), INFORMATION)
		if alldates[#alldates] == _activeDate then
			print("Already at latest date")
		else
			changed = true
			if m=="L" then
				_activeDate = alldates[#alldates]
				Debug(string.format("L: ad = %s", _activeDate), DETAIL)
			else
				local ix
				for k,v in ipairs(alldates) do
					if v == _activeDate then
						ix = k+1
						break
					end
				end
				_activeDate = alldates[ix]
				Debug(string.format("N: ad = %s", _activeDate), DETAIL)
			end
		end
	elseif (m=="P" or m=="F") then
		Debug(string.format("m: %s [%s] [%s]", m, alldates[#alldates], _activeDate), INFORMATION)
		if alldates[1] == _activeDate then
			print("Already at earliest date")
		else
			changed = true
			if m == "F" then
				_activeDate = alldates[1]
				Debug(string.format("F: ad = %s", _activeDate), DETAIL)
			else
				local ix
				for k,v in ipairs(alldates) do
					if v == _activeDate then
						ix = k-1
						break
					end
				end
				_activeDate = alldates[ix]
				Debug(string.format("P: ad = %s", _activeDate), DETAIL)
			end
		end
	end	
	Debug(string.format("changed = %s", tostring(changed)), INFORMATION)
	if changed then
		MB.UIElements.summary.hdr_period:SetText("Period: ".._activeDate)
		for k,v in pairs(curDetails) do
			if v.seen == true then
				_sumtxtupdate[v.name] = true
			end
		end
		sumtextUpdateNeeded = true
	end
end

function MB.frameOrder()
	Debug("S:MB.frameOrder()",FUNCTIONRUN)
	local active = {}
	
	for k,v in pairs(curDetails) do
		if v.seen then
			active[v.pos] = {name=v.name, id=k}
		end
	end
	
	local PREV = MB.UIElements.summary.L3text
	
	for _,v in pairs(active) do
		local CRNT = MB.UIElements.summary.curBars[v.name]
		if v.id == "coin" then
			CRNT.icon:SetPoint("TOPLEFT", PREV.cname, "BOTTOMLEFT", 0,0)
		else
			CRNT.icon:SetPoint("TOPLEFT", PREV.icon, "BOTTOMLEFT", 0,0)
		end
		CRNT.start:SetPoint("TOPLEFT", PREV.start, "BOTTOMLEFT", 0,0)
		CRNT.gain:SetPoint("TOPLEFT", PREV.gain, "BOTTOMLEFT", 0,0)
		CRNT.loss:SetPoint("TOPLEFT", PREV.loss, "BOTTOMLEFT", 0,0)
		CRNT.nett:SetPoint("TOPLEFT", PREV.nett, "BOTTOMLEFT", 0,0)
		CRNT.crnt:SetPoint("TOPLEFT", PREV.crnt, "BOTTOMLEFT", 0,0)
		CRNT.icon:SetVisible(true)
		PREV = CRNT
	end
	
	MB.UIElements.summary.background:SetPoint("BOTTOMLEFT", PREV.icon, "BOTTOMLEFT", 0,0)
	
	resizeNeeded = true
	Debug("E:MB.frameOrder()",FUNCTIONRUN)
end

function MB.mk_sumFrame(k, v)
	local iconSrc
	local iconImg
	local cname = v.name
	
	WATCHDOGWAIT("mk_sumFrame:1")
	MB.UIElements.summary.curBars[cname] = {}
	MB.UIElements.summary.curBars[cname].icon = UI.CreateFrame("Texture", "MB.UIElements.summary.curBars."..cname, MB.UIElements.summary.hdr_background)
	MB.UIElements.summary.curBars[cname].icon:SetVisible(false)
	MB.UIElements.summary.curBars[cname].icon:SetLayer(1)
	if k == "coin" then
		iconSrc = addon.identifier
		iconImg = "textures/platinum.png"
	elseif k == "credit" then
		iconSrc = addon.identifier
		iconImg = "textures/credits.png"	
	else
		iconSrc = "Rift"
		iconImg = v.icon
	end
	WATCHDOGWAIT("BuildUIElements:SetTexture:"..iconImg)
	MB.UIElements.summary.curBars[cname].icon:SetTexture(iconSrc, iconImg)

	WATCHDOGWAIT("mk_sumFrame:2")
	MB.UIElements.summary.curBars[cname].cname= UI.CreateFrame("Text", "cname"..cname, MB.UIElements.summary.curBars[cname].icon)
	MB.UIElements.summary.curBars[cname].cname:SetText(cname)
	MB.UIElements.summary.curBars[cname].cname:SetPoint("TOPLEFT", MB.UIElements.summary.curBars[cname].icon, "TOPRIGHT", 0,0)		
	MB.UIElements.summary.curBars[cname].cname:SetLayer(1)
	
	MB.UIElements.summary.curBars[cname].start = UI.CreateFrame("Text", "start"..cname, MB.UIElements.summary.curBars[cname].icon)
	MB.UIElements.summary.curBars[cname].start:SetLayer(1)
	MB.UIElements.summary.curBars[cname].gain  = UI.CreateFrame("Text", "gain"..cname, MB.UIElements.summary.curBars[cname].icon)
	MB.UIElements.summary.curBars[cname].gain:SetFontColor(0,1,0)
	MB.UIElements.summary.curBars[cname].gain:SetLayer(1)
	MB.UIElements.summary.curBars[cname].loss  = UI.CreateFrame("Text", "loss"..cname, MB.UIElements.summary.curBars[cname].icon)
	MB.UIElements.summary.curBars[cname].loss:SetFontColor(1,0,0)
	MB.UIElements.summary.curBars[cname].loss:SetLayer(1)
	MB.UIElements.summary.curBars[cname].nett  = UI.CreateFrame("Text", "nett"..cname, MB.UIElements.summary.curBars[cname].icon)
	MB.UIElements.summary.curBars[cname].nett:SetLayer(1)
	MB.UIElements.summary.curBars[cname].crnt  = UI.CreateFrame("Text", "crnt"..cname, MB.UIElements.summary.curBars[cname].icon)
	MB.UIElements.summary.curBars[cname].crnt:SetLayer(1)
	
	_sumtxtupdate[cname] = true
end

function MB.FormatSep(a)
	if a >= 1000 then
		local s = ""
		local f = true
		while a>1000 do
			nx = math.floor(a/1000)
			if f then
				s = string.format("%03d", (a-(1000*nx)))
				f = false
			else
				s = string.format("%03d,%s", (a-(1000*nx)), s)
			end
			a=nx
		end
		s=a..","..s
		return s
	else
		return tostring(a)
	end
end

function MB.FormatCurrency(c,a)
	if curDetailsRev[1].name == c then
		local p = math.floor(a/10000)
		a=a-(10000*p)
		local g = math.floor(a/100)
		local s = a-(100*g)
		return(string.format("%sp%02dg%02ds", MB.FormatSep(p),g,s))
	else
		return(string.format("%s", MB.FormatSep(a)))
	end
end

function MB.SetTrackerText()
	local active = MoneyBags_Settings.active
	local id = curDetailsRev[active].id
	local cname
	if curDetails[id].seen then
		cname = curDetails[id].name
	else
		cname = curDetails["coin"].name
	end
	MB.UIElements.tracker.curName:SetText(cname)
	local w = MB.UIElements.tracker.curName:GetWidth()
	MB.UIElements.tracker.frDims.hdr_tw = w
	
	local start = MoneyBags_Settings.history[_CurrentDay][cname].start
	local gain = MoneyBags_Settings.history[_CurrentDay][cname].gain
	local loss = MoneyBags_Settings.history[_CurrentDay][cname].loss
	local diff = gain+loss
	
	local crnt = start + diff
	
	if diff<0 then
		MB.UIElements.tracker.curNett:SetFontColor(1,0,0)
	else
		MB.UIElements.tracker.curNett:SetFontColor(0,1,0)
	end
	
	MB.UIElements.tracker.curCurrent:SetText(MB.FormatCurrency(cname,crnt))
	local w1 = MB.UIElements.tracker.curCurrent:GetWidth()
	MB.UIElements.tracker.curGain:SetText(MB.FormatCurrency(cname,gain))
	local w2 = MB.UIElements.tracker.curGain:GetWidth()
	MB.UIElements.tracker.curLoss:SetText(MB.FormatCurrency(cname,loss))
	local w3 = MB.UIElements.tracker.curLoss:GetWidth()
	MB.UIElements.tracker.curNett:SetText(MB.FormatCurrency(cname,diff))
	local w4 = MB.UIElements.tracker.curNett:GetWidth()
	
	w = math.max(w1,w2,w3,w4)
	MB.UIElements.tracker.frDims.val_w = MB.UIElements.tracker.frDims.lbl_w+w
	
	w = math.max(MB.UIElements.tracker.frDims.hdr_tw, MB.UIElements.tracker.frDims.val_w)
	MB.UIElements.tracker.hdr_background:SetWidth(w)

	w = math.max(MB.UIElements.tracker.frDims.hdr_tw, MB.UIElements.tracker.frDims.val_w, (MB.UIElements.tracker.frDims.w32*4))
	MB.UIElements.controlpanel.frame:SetWidth(w)
	MB.UIElements.controlpanel.panel:SetWidth(w)
end

function MB.Event_Currency(h,e)
	for k,v in pairs(e) do
		if curDetails[k] == nil then
			local d = Inspect.Currency.Detail(k)
			MB.mk_sumFrame(k, d)
			print(string.format("NOTICE: New currency detected [%s,%s]", d.name, k))
			numKnownCurrency = numKnownCurrency+1
			curDetails[k] = {name = d.name, pos=numKnownCurrency, seen=true, iName = d.icon}
			curDetailsRev[numKnownCurrency] = { name=d.name, id = k }
			local cname = curDetails[k].name
			MoneyBags_Settings.history[_CurrentDay][cname] = { start=0, gain=0, loss=0}
			MoneyBags_Settings.monthly[_CurrentMth][cname] = { start=0, gain=0, loss=0}
			_session[cname] = { start=0, gain=0, loss=0}
		end
		
		local cname = curDetails[k].name
		
		if _session[cname] == nil then
			_session[cname] = { start=0, gain=0, loss=0}
		end
		
		if MoneyBags_Settings.history[_CurrentDay][cname] == nil then
			MoneyBags_Settings.history[_CurrentDay][cname] = { start=0, gain=0, loss=0}
		end
		
		if MoneyBags_Settings.monthly[_CurrentMth][cname] == nil then
			MoneyBags_Settings.monthly[_CurrentMth][cname] = { start=0, gain=0, loss=0}
		end
		
		local calc = MoneyBags_Settings.history[_CurrentDay][cname].start + MoneyBags_Settings.history[_CurrentDay][cname].gain + MoneyBags_Settings.history[_CurrentDay][cname].loss

		if calc ~= v then
			local d = v - calc
			if d > 0 then
				MoneyBags_Settings.history[_CurrentDay][cname].gain = MoneyBags_Settings.history[_CurrentDay][cname].gain+d
				MoneyBags_Settings.monthly[_CurrentMth][cname].gain = MoneyBags_Settings.monthly[_CurrentMth][cname].gain+d
				_session[cname].gain = _session[cname].gain+d
			elseif d < 0 then
				MoneyBags_Settings.history[_CurrentDay][cname].loss = MoneyBags_Settings.history[_CurrentDay][cname].loss+d
				MoneyBags_Settings.monthly[_CurrentMth][cname].loss = MoneyBags_Settings.monthly[_CurrentMth][cname].loss+d
				_session[cname].loss = _session[cname].loss+d
			end
		end
		
		if curDetails[k].pos == MoneyBags_Settings.active then
			MB.SetTrackerText()
		end
		
		_sumtxtupdate[cname] = true
		Debug("CUREVNT: "..cname,INFORMATION)
	end
	if (_summode == "D" and (_CurrentDay == _activeDate))
	or (_summode == "M" and (_CurrentMth ~= _activeDate))
	or (_summode == "S") then
		sumtextUpdateNeeded = true
	end
end

function MB.StartSession()
	Debug("S:StartSession()",FUNCTIONRUN)
	for k,v in pairs(Inspect.Currency.Detail(Inspect.Currency.List())) do
		WATCHDOGWAIT("StartSession:1")
		
		local cname = v.name
		local ACTUAL= v.stack
		ACTUAL = ACTUAL or 0
		
		if firstrun then
			if _daystart[cname] ~= nil then
				MoneyBags_Settings.history[_CurrentDay][cname] = {start=_daystart[cname].start, gain=0, loss=0}
			else
				MoneyBags_Settings.history[_CurrentDay][cname] = {start=0, gain=0, loss=0}
			end
		end
		
		if MoneyBags_Settings.monthly[_CurrentMth][cname] == nil then
			if _daystart[cname] ~= nil then
				MoneyBags_Settings.monthly[_CurrentMth][cname] = {start=_daystart[cname].start, gain=0, loss=0}
			else
				MoneyBags_Settings.monthly[_CurrentMth][cname] = {start=0, gain=0, loss=0}
			end
		end
				
		-- Sanity check current day
		
		if MoneyBags_Settings.history[_CurrentDay][cname] == nil then
			MoneyBags_Settings.history[_CurrentDay][cname] = { start=0, gain=0, loss=0}
		end
		
		local CALC = MoneyBags_Settings.history[_CurrentDay][cname].start + MoneyBags_Settings.history[_CurrentDay][cname].gain + MoneyBags_Settings.history[_CurrentDay][cname].loss
		CALC = CALC or 0
		local d = ACTUAL - CALC

		if d < 0 then
			MoneyBags_Settings.history[_CurrentDay][cname].loss = MoneyBags_Settings.history[_CurrentDay][cname].loss+d
			print(string.format("Difference in actual vs calculated: %d vs %d = %d", ACTUAL, CALC, d))
			print(string.format("Adding daily adj [LOSS] of %d to %s", d, cname))
			Debug(string.format("[%d+%d+%d = %d]. Actual = %d (%d). Diff = %d",
				MoneyBags_Settings.history[_CurrentDay][cname].start,MoneyBags_Settings.history[_CurrentDay][cname].gain,MoneyBags_Settings.history[_CurrentDay][cname].loss, CALC,
				v.stack, _daystart[cname].start, d),DETAIL)
		elseif d > 0 then
			print(string.format("Difference in actual vs calculated: %d vs %d = %d", ACTUAL, CALC, d))
			print(string.format("Adding daily adj [GAIN] of %d to %s", d, cname))
			Debug(string.format("[%d+%d+%d = %d]. Actual = %d (%d). Diff = %d",
				MoneyBags_Settings.history[_CurrentDay][cname].start,MoneyBags_Settings.history[_CurrentDay][cname].gain,MoneyBags_Settings.history[_CurrentDay][cname].loss, CALC,
				v.stack, _daystart[cname].start, d),DETAIL)
			MoneyBags_Settings.history[_CurrentDay][cname].gain = MoneyBags_Settings.history[_CurrentDay][cname].gain+d
		end
		
		-- sanity check current month
		CALC = MoneyBags_Settings.monthly[_CurrentMth][cname].start + MoneyBags_Settings.monthly[_CurrentMth][cname].gain + MoneyBags_Settings.monthly[_CurrentMth][cname].loss
		if CALC ~= ACTUAL then
			d = ACTUAL - CALC
			if d>0 then
				MoneyBags_Settings.monthly[_CurrentMth][cname].gain = MoneyBags_Settings.monthly[_CurrentMth][cname].gain + d
			elseif d<0 then
				MoneyBags_Settings.monthly[_CurrentMth][cname].loss = MoneyBags_Settings.monthly[_CurrentMth][cname].loss + d
			end
		end
		
		-- Sanity check current session		
		local d = _daystart[cname].start - v.stack
		if d < 0 then
			_session[cname].loss = _session[cname].loss+d
		elseif d>0 then
			_session[cname].gain = _session[cname].gain+d
		end
	end
	firstrun = false
	Command.Event.Attach(Event.Currency, MB.Event_Currency, "Event.Currency")
	Debug("E:StartSession()",FUNCTIONRUN)
end

function MB.SVLoaded()
	Debug("S:SVLoaded()",FUNCTIONRUN)
	MoneyBags_Settings = MoneyBags_Settings or {}
	if not MINIMAPDOCKER then
		if MoneyBags_Settings.mmx ~= nil then
			MB.UIElements.minimap:SetPoint("TOPLEFT", UIParent, "TOPLEFT", MoneyBags_Settings.mmx, MoneyBags_Settings.mmy)
		else
			MB.UIElements.minimap:SetPoint("TOPLEFT", UI.Native.MapMini, "BOTTOMCENTER", 0,0)
			MoneyBags_Settings.mmx = MB.UIElements.minimap:GetLeft()
			MoneyBags_Settings.mmy = MB.UIElements.minimap:GetTop()
		end
	end
	MergeTable(MoneyBags_Settings, default_settings)
	if not MoneyBags_Settings.history[_CurrentDay] then
		print("No data for today. Creating.")
		MoneyBags_Settings.history[_CurrentDay] = {}
		firstrun = true
	end
	local _allmths = {}
	MoneyBags_Settings.monthly[_CurrentMth] = {}
	for k,v in pairs(MoneyBags_Settings.history) do
		if string.sub(k,1,6) == _CurrentMth then
			table.insert(_allmths, k)
		end
	end
	table.sort(_allmths)
	for _,v in ipairs(_allmths) do
		for cn, cv in pairs(MoneyBags_Settings.history[v]) do
			if not MoneyBags_Settings.monthly[_CurrentMth][cn] then
				MoneyBags_Settings.monthly[_CurrentMth][cn] = {
					start = cv.start, gain = cv.gain, loss = cv.loss
					}
			else
				MoneyBags_Settings.monthly[_CurrentMth][cn].gain = MoneyBags_Settings.monthly[_CurrentMth][cn].gain + cv.gain
				MoneyBags_Settings.monthly[_CurrentMth][cn].loss = MoneyBags_Settings.monthly[_CurrentMth][cn].loss + cv.loss
			end
		end
	end
	MB.UIElements.tracker.icon:SetVisible(MoneyBags_Settings.visible)
	MB.UIElements.tracker.icon:SetPoint("TOPLEFT", UIParent, "TOPLEFT", MoneyBags_Settings.x, MoneyBags_Settings.y)
	MB.UIElements.summary.hdr_background:SetPoint("TOPLEFT", UIParent, "TOPLEFT", MoneyBags_Settings.sumx, MoneyBags_Settings.sumy)
	
	MB.StartSession()	
	MB.scaleTracker()
	Debug("E:SVLoaded()",FUNCTIONRUN)
end

function MB.frameResize()
	Debug("S:frameResize()", FUNCTIONRUN)
	local scale = MoneyBags_Settings.sumscale or 1
	local w32 = 32 * scale
	local h24 = 24 * scale
	local h18 = 18 * scale
	local h12 = 12 * scale

	WATCHDOGWAIT("frameResize:1")
	
	MB.UIElements.summary.frDims.actual = { cncy=0, strt=0, gain=0, loss=0, nett=0, crnt=0 }
	MB.UIElements.summary.frDims.header = { cncy=0, strt=0, gain=0, loss=0, nett=0, crnt=0 }
	MB.UIElements.summary.frDims.detail = { icon=0, cncy=0, strt=0, gain=0, loss=0, nett=0, crnt=0 }
	
	MB.UIElements.summary.hdr_text:SetFontSize(h24)
	local h_l1 = MB.UIElements.summary.hdr_text:GetHeight()
	local w_l1 = MB.UIElements.summary.hdr_text:GetWidth()
	MB.UIElements.summary.L1:SetHeight(h_l1)
	
	MB.UIElements.summary.hdr_period:SetFontSize(h18)
	local h_l2 = MB.UIElements.summary.hdr_period:GetHeight()
	local w_l2 = MB.UIElements.summary.hdr_period:GetWidth() + (5*h_l2)
	MB.UIElements.summary.L2:SetHeight(h_l2)

	WATCHDOGWAIT("frameResize:2")
	
	MB.UIElements.summary.L3text.cname:SetFontSize(h12)
	local h_l3 = MB.UIElements.summary.L3text.cname:GetHeight()
	MB.UIElements.summary.L3:SetHeight(h_l3)
	
	MB.UIElements.summary.L3text.cname:ClearWidth()
	MB.UIElements.summary.L3text.start:ClearWidth()
	MB.UIElements.summary.L3text.gain:ClearWidth()
	MB.UIElements.summary.L3text.loss:ClearWidth()
	MB.UIElements.summary.L3text.nett:ClearWidth()
	MB.UIElements.summary.L3text.crnt:ClearWidth()
	
	WATCHDOGWAIT("frameResize:3")

	MB.UIElements.summary.frDims.header.cncy = MB.UIElements.summary.L3text.cname:GetWidth()
	MB.UIElements.summary.L3text.start:SetFontSize(h12)
	MB.UIElements.summary.frDims.header.strt = MB.UIElements.summary.L3text.start:GetWidth()
	MB.UIElements.summary.L3text.gain:SetFontSize(h12)
	MB.UIElements.summary.frDims.header.gain = MB.UIElements.summary.L3text.gain:GetWidth()
	MB.UIElements.summary.L3text.loss:SetFontSize(h12)
	MB.UIElements.summary.frDims.header.loss = MB.UIElements.summary.L3text.loss:GetWidth()
	MB.UIElements.summary.L3text.nett:SetFontSize(h12)
	MB.UIElements.summary.frDims.header.nett = MB.UIElements.summary.L3text.nett:GetWidth()
	MB.UIElements.summary.L3text.crnt:SetFontSize(h12)
	MB.UIElements.summary.frDims.header.crnt = MB.UIElements.summary.L3text.crnt:GetWidth()
	
	MB.UIElements.summary.frDims.detail.icon = h_l3
	
	WATCHDOGWAIT("frameResize:4")

	for k,v in pairs(MB.UIElements.summary.curBars) do
		WATCHDOGWAIT("frameResize:5:"..k)
		v.icon:SetWidth(h_l3)
		v.icon:SetHeight(h_l3)
		v.cname:SetFontSize(h12)
		v.cname:SetFontSize(h12)
		v.start:SetFontSize(h12)
		v.gain:SetFontSize(h12)
		v.loss:SetFontSize(h12)
		v.nett:SetFontSize(h12)
		v.crnt:SetFontSize(h12)
		MB.UIElements.summary.frDims.detail.cncy = math.max(MB.UIElements.summary.frDims.detail.cncy, v.cname:GetWidth())
		MB.UIElements.summary.frDims.detail.strt = math.max(MB.UIElements.summary.frDims.detail.strt, v.start:GetWidth())
		MB.UIElements.summary.frDims.detail.gain = math.max(MB.UIElements.summary.frDims.detail.gain, v.gain:GetWidth())
		MB.UIElements.summary.frDims.detail.loss = math.max(MB.UIElements.summary.frDims.detail.loss, v.loss:GetWidth())
		MB.UIElements.summary.frDims.detail.nett = math.max(MB.UIElements.summary.frDims.detail.nett, v.nett:GetWidth())
		MB.UIElements.summary.frDims.detail.crnt = math.max(MB.UIElements.summary.frDims.detail.crnt, v.crnt:GetWidth())
	end

	WATCHDOGWAIT("frameResize:6")
	
	MB.UIElements.summary.frDims.actual.cncy = math.max(MB.UIElements.summary.frDims.header.cncy,(MB.UIElements.summary.frDims.detail.icon+MB.UIElements.summary.frDims.detail.cncy))
	MB.UIElements.summary.frDims.actual.strt = math.max(MB.UIElements.summary.frDims.header.strt,MB.UIElements.summary.frDims.detail.strt)
	MB.UIElements.summary.frDims.actual.gain = math.max(MB.UIElements.summary.frDims.header.gain,MB.UIElements.summary.frDims.detail.gain)
	MB.UIElements.summary.frDims.actual.loss = math.max(MB.UIElements.summary.frDims.header.loss,MB.UIElements.summary.frDims.detail.loss)
	MB.UIElements.summary.frDims.actual.nett = math.max(MB.UIElements.summary.frDims.header.nett,MB.UIElements.summary.frDims.detail.nett)
	MB.UIElements.summary.frDims.actual.crnt = math.max(MB.UIElements.summary.frDims.header.crnt,MB.UIElements.summary.frDims.detail.crnt)
	
	MB.UIElements.summary.L3text.cname:SetWidth(MB.UIElements.summary.frDims.actual.cncy)
	MB.UIElements.summary.L3text.start:SetWidth(MB.UIElements.summary.frDims.actual.strt)
	MB.UIElements.summary.L3text.gain:SetWidth(MB.UIElements.summary.frDims.actual.gain)
	MB.UIElements.summary.L3text.loss:SetWidth(MB.UIElements.summary.frDims.actual.loss)
	MB.UIElements.summary.L3text.nett:SetWidth(MB.UIElements.summary.frDims.actual.nett)
	MB.UIElements.summary.L3text.crnt:SetWidth(MB.UIElements.summary.frDims.actual.crnt)

	WATCHDOGWAIT("frameResize:7")

	local w_l3 = MB.UIElements.summary.frDims.actual.cncy + MB.UIElements.summary.frDims.actual.strt + MB.UIElements.summary.frDims.actual.gain + MB.UIElements.summary.frDims.actual.loss + MB.UIElements.summary.frDims.actual.nett + MB.UIElements.summary.frDims.actual.crnt

	MB.UIElements.summary.frDims.actual.w_l1 = w_l1
	MB.UIElements.summary.frDims.actual.w_l2 = w_l2
	MB.UIElements.summary.frDims.actual.w_l3 = w_l3
	
	local frw = math.max(w_l1, w_l2, w_l3)
	MB.UIElements.summary.frDims.actual.frw = frw
	
	MB.UIElements.summary.hdr_background:SetHeight(h_l1+h_l2+h_l3)
	MB.UIElements.summary.hdr_background:SetWidth(frw)
	MB.UIElements.summary.background:SetWidth(frw)

	MB.UIElements.summary.L1:SetWidth(frw)
	MB.UIElements.summary.L2:SetWidth(frw)
	MB.UIElements.summary.L3:SetWidth(frw)
	
	WATCHDOGWAIT("frameResize:8")

	MB.UIElements.summary.ctrl_cncl:SetWidth(h_l2)
	MB.UIElements.summary.ctrl_cncl:SetHeight(h_l2)
	MB.UIElements.summary.ctrl_strt:SetWidth(h_l2)
	MB.UIElements.summary.ctrl_strt:SetHeight(h_l2)
	MB.UIElements.summary.ctrl_rewd:SetWidth(h_l2)
	MB.UIElements.summary.ctrl_rewd:SetHeight(h_l2)
	MB.UIElements.summary.ctrl_end:SetWidth(h_l2)
	MB.UIElements.summary.ctrl_end:SetHeight(h_l2)
	MB.UIElements.summary.ctrl_ffor:SetWidth(h_l2)
	MB.UIElements.summary.ctrl_ffor:SetHeight(h_l2)

	WATCHDOGWAIT("frameResize:9")
	Debug("E:frameResize()", FUNCTIONRUN)
end

function MB.sumtextUpdate()
	Debug("S:MB.sumtextUpdate()",FUNCTIONRUN)
	Debug(string.format("M: %s, _cd: %s, _cm: %s, ad: %s", _summode, _CurrentDay, _CurrentMth, _activeDate),INFORMATION)
	
--[[	if (_summode == "D" and (_CurrentDay ~= _activeDate))
	or (_summode == "M" and (_CurrentMth ~= _activeDate)) then
		-- sum not showing today, so exit w/ no changes
		return
	end
]]	
	local dtls = {}	
	
	if _summode == "D" then
		Debug(string.format("Update for mode:%s date:%s", _summode, _activeDate),DETAIL)
		dtls = MoneyBags_Settings.history[_activeDate]
	elseif _summode == "M" then
		Debug(string.format("Update for mode:%s date:%s", _summode, _activeDate),DETAIL)
		dtls = MoneyBags_Settings.monthly[_activeDate]
	else
		Debug(string.format("Update for mode:%s", _summode),DETAIL)
		dtls = _session
	end
	
	local s,g,l,n,c,w
	local changed = false
	
	for k,_ in pairs(_sumtxtupdate) do
		Debug("Update: "..k,DETAIL)
		if dtls[k] ~= nil then
			s = dtls[k].start
			g = dtls[k].gain
			l = dtls[k].loss
		else
			s = 0
			g = 0
			l = 0
		end
		
		n = g+l
		c = s + n
		
		if MB.UIElements.summary.curBars[k] ~= nil then
		
			MB.UIElements.summary.curBars[k].start:SetText(MB.FormatCurrency(k,s))
			MB.UIElements.summary.curBars[k].gain:SetText(MB.FormatCurrency(k,g))
			MB.UIElements.summary.curBars[k].loss:SetText(MB.FormatCurrency(k,(0-l)))
			MB.UIElements.summary.curBars[k].crnt:SetText(MB.FormatCurrency(k,c))
			
			if n < 0 then
				MB.UIElements.summary.curBars[k].nett:SetText(MB.FormatCurrency(k,(0-n)))
				MB.UIElements.summary.curBars[k].nett:SetFontColor(1,0,0)
			elseif n > 0 then
				MB.UIElements.summary.curBars[k].nett:SetText(MB.FormatCurrency(k,n))
				MB.UIElements.summary.curBars[k].nett:SetFontColor(0,1,0)
			else
				MB.UIElements.summary.curBars[k].nett:SetText(MB.FormatCurrency(k,n))
				MB.UIElements.summary.curBars[k].nett:SetFontColor(1,1,1)
			end
			_sumtxtupdate[k] = nil
			
			w = MB.UIElements.summary.curBars[k].start:GetWidth()
			if w > MB.UIElements.summary.frDims.detail.strt then
				MB.UIElements.summary.frDims.detail.strt = w
				changed = true
			end
			w = MB.UIElements.summary.curBars[k].gain:GetWidth()
			if w > MB.UIElements.summary.frDims.detail.gain then
				MB.UIElements.summary.frDims.detail.gain = w
				changed = true
			end
			w = MB.UIElements.summary.curBars[k].loss:GetWidth()
			if w > MB.UIElements.summary.frDims.detail.loss then
				MB.UIElements.summary.frDims.detail.loss = w
				changed = true
			end
			w = MB.UIElements.summary.curBars[k].crnt:GetWidth()
			if w > MB.UIElements.summary.frDims.detail.crnt then
				MB.UIElements.summary.frDims.detail.crnt = w
				changed = true
			end
			w = MB.UIElements.summary.curBars[k].nett:GetWidth()
			if w > MB.UIElements.summary.frDims.detail.nett then
				MB.UIElements.summary.frDims.detail.nett = w
				changed = true
			end
		end
	end
	if changed then
		MB.UIElements.summary.frDims.actual.strt = math.max(MB.UIElements.summary.frDims.header.strt,MB.UIElements.summary.frDims.detail.strt)
		MB.UIElements.summary.frDims.actual.gain = math.max(MB.UIElements.summary.frDims.header.gain,MB.UIElements.summary.frDims.detail.gain)
		MB.UIElements.summary.frDims.actual.loss = math.max(MB.UIElements.summary.frDims.header.loss,MB.UIElements.summary.frDims.detail.loss)
		MB.UIElements.summary.frDims.actual.nett = math.max(MB.UIElements.summary.frDims.header.nett,MB.UIElements.summary.frDims.detail.nett)
		MB.UIElements.summary.frDims.actual.crnt = math.max(MB.UIElements.summary.frDims.header.crnt,MB.UIElements.summary.frDims.detail.crnt)

		MB.UIElements.summary.L3text.start:SetWidth(MB.UIElements.summary.frDims.actual.strt)
		MB.UIElements.summary.L3text.gain:SetWidth(MB.UIElements.summary.frDims.actual.gain)
		MB.UIElements.summary.L3text.loss:SetWidth(MB.UIElements.summary.frDims.actual.loss)
		MB.UIElements.summary.L3text.nett:SetWidth(MB.UIElements.summary.frDims.actual.nett)
		MB.UIElements.summary.L3text.crnt:SetWidth(MB.UIElements.summary.frDims.actual.crnt)

		local w_l3 = MB.UIElements.summary.frDims.actual.cncy + MB.UIElements.summary.frDims.actual.strt + MB.UIElements.summary.frDims.actual.gain + MB.UIElements.summary.frDims.actual.loss + MB.UIElements.summary.frDims.actual.nett + MB.UIElements.summary.frDims.actual.crnt
		
		MB.UIElements.summary.frDims.actual.w_l3 = w_l3

		local frw = math.max(MB.UIElements.summary.frDims.actual.w_l1, MB.UIElements.summary.frDims.actual.w_l2, MB.UIElements.summary.frDims.actual.w_l3)
		if frw > MB.UIElements.summary.frDims.actual.frw then
			Debug(string.format("Frame size changing: %d -> %d", MB.UIElements.summary.frDims.actual.frw, frw),DETAIL)
			MB.UIElements.summary.frDims.actual.frw = frw
			MB.UIElements.summary.hdr_background:SetWidth(frw)
			MB.UIElements.summary.background:SetWidth(frw)
			MB.UIElements.summary.L1:SetWidth(frw)
			MB.UIElements.summary.L2:SetWidth(frw)
			MB.UIElements.summary.L3:SetWidth(frw)
		end
	end
	Debug("E:MB.sumtextUpdate()",FUNCTIONRUN)
end

function MB.UpdateHandler()
	while true do
		if controlvis then
			MB.checkMouse()
		end
		if frNeeded then
			Debug("building UI frames",STATUSUPDT)
			MB.BuildUIElements()
			frNeeded = false
		elseif svLoaded then
			Debug("handling SV",STATUSUPDT)
			MB.SVLoaded()
			svLoaded = false
			frameOrderNeeded = true
			sumtextUpdateNeeded = true
			LibVersionCheck.register(addon.toc.Identifier, addon.toc.Version)
		elseif frameOrderNeeded then
			Debug("reorder of frames needed",STATUSUPDT)
			MB.frameOrder()
			frameOrderNeeded = false
		elseif resizeNeeded then
			Debug("rescale of sum frames needed",STATUSUPDT)
			MB.frameResize()
			resizeNeeded = false
			Debug("yield total: "..yieldcnt,STATUSUPDT)
		elseif sumtextUpdateNeeded then
			Debug("summary text update needed",STATUSUPDT)
			MB.sumtextUpdate()
			sumtextUpdateNeeded = false
		end
		coroutine.yield()
	end
end

MB.coUpdateHandler = coroutine.create(MB.UpdateHandler)

function MB.Event_System_Update_Begin(h)
	if coroDead then return end
	local ok, errormsg = coroutine.resume(MB.coUpdateHandler)
	if not ok then
		coroDead = true
		error("Error in coroutine: "..errormsg)
	end
end

function MB.Command_Slash_Register(h, args)
	local r = {}
	local numargs = 0
	for token in string.gmatch(args, "[^%s]+") do
		r[numargs] = token
		numargs=numargs+1
	end
	if numargs > 0 then
		if r[0] == "scale" then
			if numargs == 2 then
				local scale = tonumber(r[1]) or 1
				if scale > 0 then
					print("Setting scale to: "..scale)
					MoneyBags_Settings.scale = scale
					MB.scaleTracker()
				else
					print("Negative scales make no sense!")
				end
			else
				print("Need a scale value")
			end
		elseif r[0] == "sumscale" then
			if numargs == 2 then
				local scale = tonumber(r[1]) or 1
				if scale > 0 then
					print("Setting summary scale to: "..scale)
					MoneyBags_Settings.sumscale = scale
					resizeNeeded = true
				else
					print("Negative scales make no sense!")
				end
			else
				print("Need a scale value")
			end		
		--elseif r[0] == "sumscale" then
		else
			print "\t/mbags scale N.NN - Scales the currency tracker display"
			print "\t/mbags sumscale N.NN - Scales the currency tracker summary display"
		end
	end
end

function MB.Event_Addon_SavedVariables_Load_End(h,a)
	if a == addon.identifier then
		svLoaded = true
	end
end

for k,v in pairs(curSetup) do
	curDetails[v.k] = { name=v.name, pos=k, iSrc = v.iSrc, iName = v.iName, seen = false }
	curDetailsRev[k] = {name = v.name, id = v.k}
end

---------------------
-- Events
---------------------

Command.Event.Attach(Event.Addon.SavedVariables.Load.End, MB.Event_Addon_SavedVariables_Load_End, "Event.Addon.SavedVariables.Load.End")
Command.Event.Attach(Command.Slash.Register("mbags"), MB.Command_Slash_Register, "Command.Slash.Register")
Command.Event.Attach(Event.System.Update.Begin, MB.Event_System_Update_Begin, "Event.System.Update.Begin")

print(string.format("v%s loaded.", addon.toc.Version))